/**************************************
 * NOTE: This source code is free and 
 * comes with ABSOLUTELY NO WARRANTY.
 * 
 * @author Daniel Muenter, 2006
 * 
 **************************************/

// A table is a 2D array
var datatable = new Array();
var dtbackup = new Array();
var currentTable = null;
var tree = null;
var sorted = false;
var filter = 'none';

// colName:[index, order, isnumber]
var datacols = {
	type 	: [ 0, 0, 0 ],
	comment : [ 1, 0, 0 ],
	left 	: [ 2, 0, 0 ],
	date 	: [ 3, 0, 0 ],
	item 	: [ 4, 0, 0 ]
};
var rowcount = 0;

function addItem(item) {
	if (tree == null) {
		initTreeView();
	}
	datatable.push(item);
	dtbackup.push(item);
	rowcount++;
	if (sorted) {
		var column = document.getElementById('type');
		sortcolumn(column);
	} else if (filter != 'none') {
		filterByType(filter);
	} else {
		tree.view = new treeView(datatable, datacols, rowcount);
		currentTable = datatable;
	}
}

function getDataTable() {
	return currentTable;
}

function resetTree() {
	datatable = new Array();
	dtbackup = new Array();
	rowcount = 0;
	tree.view = new treeView(datatable, datacols, rowcount);
	currentTable = datatable;
	sorted = false;
	filter = 'none';
}

function initTreeView() {
	tree = document.getElementById('list');
	tree.view = new treeView(datatable, datacols, rowcount);
	currentTable = datatable;
}

function showAll() {
	tree.view = new treeView(dtbackup, datacols, rowcount);
	currentTable = dtbackup;
}

function filterByType(type) {
	filter = type;
	var count = 0;
	var filtered = new Array();
	for ( var i = 0; i < datatable.length; i++) {
		if (datatable[i][0] == type) {
			filtered.push(datatable[i]);
			count++;
		}
	}
	tree.view = new treeView(filtered, datacols, count);
	currentTable = filtered;
}

// This function will be called everytime we click on a column header
function sortcolumn(column) {
	var name = column.getAttribute("id");
	var index = datacols[name][0];
	var order = 0;
	var isnum = true;
	tableSort(datatable, index, order, false); // sort the table
	tree.view = new treeView(datatable, datacols, rowcount); // bind to tree
	currentTable = datatable;
	sorted = true;
}

// This is the actual sorting method, extending the array.sort() method
function tableSort(table, col, order, isnum) {
	col = 6; // insures only sort by comment type
	function columnSort(a, b) {
		return (a[col] - b[col]);
	}
	// use array.sort(comparer) method
	table.sort(columnSort);
}

// This is our custom view, based on the treeview interface
function treeView(table, columns, rowcount) {

	this.atomService = Components.classes["@mozilla.org/atom-service;1"]
			.getService(Components.interfaces.nsIAtomService);
	this.table = table; // our table
	this.columns = columns; // our cols
	this.rowCount = rowcount; // our counter
	this.setTree = function(treebox) {
		this.treebox = treebox;
	};
	this.isContainer = function(row) {
		return false;
	};
	this.isSeparator = function(row) {
		return false;
	};
	this.isSorted = function(row) {
		return false;
	};
	this.getLevel = function(row) {
		return 0;
	};
	this.getImageSrc = function(row, col) {
		return null;
	};
	this.cycleHeader = function(col) {
	};
	this.getCellProperties = function(row, col, props) {
	};
	this.getColumnProperties = function(col, properties) {
	};

	this.getRowProperties = function(row, properties) {

		if (this.table[row][0] == "negative") {
			properties.AppendElement(this.atomService.getAtom("negative"));
		} else if (this.table[row][0] == "neutral") {
			properties.AppendElement(this.atomService.getAtom("neutral"));
		} else if (this.table[row][0] == "positive") {
			properties.AppendElement(this.atomService.getAtom("positive"));
		} else if (this.table[row][0] == "withdrawn") {
			properties.AppendElement(this.atomService.getAtom("withdrawn"));
		}
	};

	this.getCellText = function(row, column) {
		return this.table[row][this.columns[column.id][0]];
	};
}
